/**
* @author Dirk Nordmann
* @date   14.01.2002
*/
package xml2rtf.rtf;

public abstract class HtmlObject
{
    public static String translateSpecialChars(String s)
    {
        return translateSpecialChars(s, false);
    }

    public static String translateSpecialChars(String s, boolean flag)
    {
        int i = 0;
        while((i = s.indexOf('&', i)) >= 0) 
        {
            boolean flag1 = false;
            String s2 = null;
            try
            {
                if(s.charAt(i + 1) == ' ')
                {
                    i++;
                    continue;
                }
                int k = s.indexOf(32, i);
                int j = s.indexOf(';', i);
                if(j == -1)
                {
                    j = s.indexOf(164, i);
                    flag1 = j > -1;
                }
                if(k > i && k < j)
                    j = -1;
                if(j <= 0)
                    break;
                String s1 = s.substring(i + 1, j);
                try
                {
                    if(s1.charAt(0) == '#')
                    {
                        try
                        {
                            int l = Integer.parseInt(s1.substring(1));
                            if(l < 32)
                                s2 = null;
                            else
                                s2 = Integer.toHexString(l);
                        }
                        catch(NumberFormatException _ex)
                        {
                            s2 = null;
                        }
                    } else
                    {
                        for(int i1 = 0; i1 < Specials.length; i1++)
                        {
                            if(!Specials[i1][0].equals(s1))
                                continue;
                            if(flag)
                                s2 = Specials[i1][2];
                            else
                                s2 = Specials[i1][1];
                            break;
                        }

                    }
                }
                catch(StringIndexOutOfBoundsException _ex)
                {
                    s2 = null;
                }
                if(s2 != null)
                {
                    int j1 = j;
                    if(!flag1)
                        j1++;
                    if(!flag && s2.length() > 0)
                        s2 = "\\'" + s2;
                    s = s.substring(0, i) + s2 + s.substring(j1);
                } else
                {
                    i += s1.length();
                    System.out.println("[XmlObject]: Warning -- cannot translate string '&" + s1 + "' to valid char.");
                }
            }
            catch(StringIndexOutOfBoundsException _ex)
            {
                s = "&";
            }
            i++;
        }
        return s;
    }
    
    private static String Specials[][] = {
        { "quot", "22", "'"
        }, { "amp", "26", "&"
        }, { "raquo", "93", "'"
        }, { "laquo", "94", "'"
        }, { "le", "3C\\'3D", "<="
        }, { "lt", "3C", "<"
        }, { "gt", "3E", ">"
        }, { "ge", "3E\\'3D", ">="
        }, { "reg", "AE", "R"
        }, { "copy", "A9", "C"
        }, { "agrave", "E0", "\340"
        }, { "aacute", "E1", "a"
        }, { "acirc", "E2", "a"
        }, { "atilde", "E3", "a"
        }, { "auml", "E4", "a"
        }, { "aring", "E5", "a"
        }, { "aelig", "E6", "a"
        }, { "ccedil", "E7", "c"
        }, { "egrave", "E8", "e"
        }, { "eacute", "E9", "e"
        }, { "ecirc", "EA", "e"
        }, { "euml", "EB", "e"
        }, { "endash", "2D", "-"
        }, { "igrave", "EC", "i"
        }, { "iacute", "ED", "i"
        }, { "icirc", "EE", "i"
        }, { "iuml", "EF", "i"
        }, { "eth", "F0", "e"
        }, { "ntilde", "F1", "n"
        }, { "ograve", "F2", "o"
        }, { "oacute", "F3", "o"
        }, { "ocirc", "F4", "o"
        }, { "otilde", "F5", "o"
        }, { "ouml", "F6", "o"
        }, { "szlig", "DF", "s"
        }, { "ugrave", "F9", "u"
        }, { "uacute", "FA", "u"
        }, { "ucirc", "FB", "u"
        }, { "uuml", "FC", "u"
        }, { "yacute", "FD", "y"
        }, { "thorn", "FE", "t"
        }, { "yuml", "FF", "y"
        }, { "Agrave", "C0", "A"
        }, { "Aacute", "C1", "A"
        }, { "Acirc", "C2", "A"
        }, { "Atilde", "C3", "A"
        }, { "Auml", "C4", "A"
        }, { "Aring", "C5", "A"
        }, { "Aelig", "C6", "A"
        }, { "Ccedil", "C7", "C"
        }, { "Egrave", "C8", "E"
        }, { "Eacute", "C9", "E"
        }, { "Ecirc", "CA", "E"
        }, { "Euml", "CB", "E"
        }, { "Igrave", "CC", "I"
        }, { "Iacute", "CD", "I"
        }, { "Icirc", "CE", "I"
        }, { "Iuml", "CF", "I"
        }, { "Eth", "D0", "E"
        }, { "Ntilde", "D1", "N"
        }, { "Ograve", "D2", "O"
        }, { "Oacute", "D3", "O"
        }, { "Ocirc", "D4", "O"
        }, { "Otilde", "D5", "O"
        }, { "Ouml", "D6", "O"
        }, { "Oslash", "D8", "O"
        }, { "Ugrave", "D9", "U"
        }, { "Uacute", "DA", "U"
        }, { "Ucirc", "DB", "U"
        }, { "Uuml", "DC", "U"
        }, { "Yacute", "FD", "Y"
        }, { "nbsp", "20", " "
        }, { "times", "D7", "x"
        }
    };
    
}
