/**
* @author Dirk Nordmann
* @date   14.01.2002
*/
package xml2rtf.xml;

import util.*;
import java.io.*;
import java.util.StringTokenizer;


public class XmlReader 
	extends XmlTokenizer
{
    private BufferedReader bufferedreader;
    private String _filename;
    private int _numline;

    
    
    public XmlReader(String xml_file)
    {
  		_st = null;
		_numline = 0;
        _filename = xml_file;
        try
        {
            bufferedreader = new BufferedReader(new FileReader(_filename));
        }
        catch(FileNotFoundException _ex)
        {
            System.out.println("[XmlReader.constructor]: ***** FEHLER: cannot open XML file " + _filename );
            System.exit(1);
        }
    }

    
    
    public String getNextToken()
    {
        if(_st == null || !_st.hasMoreTokens())
        {
            String s = "";
            while (s.length() == 0) 
            {
                //***** Read from XML-file *****
                s = readLine();
                if (s == null)
                    return null;
                
				//***** Remove CDATA-section tags *****
				//s = StringUtil.replace(s,"<![CDATA[","");
				//s = StringUtil.replace(s,"]]>","");
        		    
				//***** Clean string *****
	   		    s = cleanString(s);
            }
            
            //***** Tokenize string *****
            _st = new StringTokenizer(s, "<>", true);
        }
        return _st.nextToken();
    }
    
    
    
public String getFilePath()
{
	return FilePathUtility.getDirectory(_filename);
}

    
    
private String readLine()
{
    //***** Dump progress info to screen *****
    _numline++;
    if(_numline % 20 == 0)
        System.err.println("   " + _numline + " lines processed...");
		
	try
	{
		String s = bufferedreader.readLine();
		return s;
	}
	catch(IOException _ex)
	{
		System.out.println("[XmlReader.readLine]: ***** I/O FEHLER: " + _ex );
		System.exit(1);
		return null;
	}
}

    
    
public void close()
{
    if(bufferedreader != null)
        try
        {
            bufferedreader.close();
        }
        catch(IOException _ex) { }
}

}